using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using DocumentFormat.OpenXml.CustomProperties;
using ILoan.Rules.Web.Services;
using Microsoft.JSInterop;
using Microsoft.AspNetCore.Components.Web;
using Radzen.Blazor;

namespace ILoan.Rules.Web.Components.Pages
{
    public partial class AddCoreRuleCriterion
    {
        [Inject]
        protected IJSRuntime JSRuntime { get; set; }

        [Inject]
        protected NavigationManager NavigationManager { get; set; }

        [Inject]
        protected DialogService DialogService { get; set; }

        [Inject]
        protected TooltipService TooltipService { get; set; }

        [Inject]
        protected ContextMenuService ContextMenuService { get; set; }

        [Inject]
        protected NotificationService NotificationService { get; set; }
        [Inject]
        public RulesService RulesService { get; set; }

        public List<string> Properties { get; set; }
        public List<string> Comparisons { get; set; }

        protected override async Task OnInitializedAsync()
        {
            Properties = RulesService.GetProperties();
            Comparisons = RulesService.GetComparisons();

            coreRulesForRuleID = await RulesService.GetCoreRules();
        }
        protected bool errorVisible;
        protected ILoan.Rules.Web.Models.Rules.CoreRuleCriterion coreRuleCriterion;

        protected IEnumerable<ILoan.Rules.Web.Models.Rules.CoreRule> coreRulesForRuleID;

        protected async Task FormSubmit()
        {
            try
            {
                await RulesService.CreateCoreRuleCriterion(coreRuleCriterion);
                DialogService.Close(coreRuleCriterion);
            }
            catch (Exception ex)
            {
                errorVisible = true;
            }
        }

        protected async Task CancelButtonClick(MouseEventArgs args)
        {
            DialogService.Close(null);
        }





        bool hasRuleIDValue;

        [Parameter]
        public int? RuleID { get; set; }
        public override async Task SetParametersAsync(ParameterView parameters)
        {
            coreRuleCriterion = new ILoan.Rules.Web.Models.Rules.CoreRuleCriterion();

            hasRuleIDValue = parameters.TryGetValue<int?>("RuleID", out var hasRuleIDResult);

            if (hasRuleIDValue)
            {
                coreRuleCriterion.RuleID = hasRuleIDResult;
            }
            await base.SetParametersAsync(parameters);
        }

        void OnChange(dynamic args)
        {
            coreRuleCriterion.Property = args;
        }
    }
}